// -*- Mode: C++ -*-

// ----------------------------------------------------------------------------
//  in_data.h
// ----------------------------------------------------------------------------

// ----------------------------------------------------------------------------
//  CN[h
// ----------------------------------------------------------------------------

#include "in_data.h"


// ----------------------------------------------------------------------------
//  ̓f[^
// ----------------------------------------------------------------------------

// ---
//  ͌`ɉďs
// ---

void in_data::init_input(const uint8 *data, uint len, uint flags)
{
  switch (flags & 0x0007)
  {
  case IN_MEMORY:  // 
    m_ptr = data;
    m_size = len;
    break;

  case IN_FILE:  // t@C
    set_error_code(SPI_ERROR_FILE_READ);
    if (!m_mf.init((const char *)data))
    {
      if (NULL != (m_ptr = (const uint8 *)m_mf.map_all()))
      {
        m_size = m_mf.get_mapped_size();

        // ŁClen ͎ۂɃf[^n܂ItZbgӖĂ
        if (m_size > len)
        {
          m_ptr += len;
          m_size -= len;
          set_error_code(SPI_OK);
        }
        else  // ItZbgt@CTCY𒴂Ă
        {
          m_ptr = NULL;
          m_size = 0;
        }
      }
    }
    break;

  default:  // Ή
    set_error_code(SPI_ERROR_NOT_IMPLEMENTED);
    break;
  }
}

